﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Padaszok_
{
    /// <summary>
    /// Fa építése az adatfile soraiból
    /// </summary>
    class FaEpit
    {
        /// <summary>
        /// Default konstruktor
        /// </summary>
        public FaEpit() { }

        /// <summary>
        /// Fa felépítése az adatokból
        /// </summary>
        /// <param name="adatok">Az adatfile sorai</param>
        /// <returns>A felépített fa</returns>
        public FaElem Epit(string[] adatok)
        {
            //Névsorrendbe rakás
            Array.Sort(adatok);
            FileElem gyokerFile = new FileElem("/ 0 0");
            FaElem gyokerElem = new FaElem(gyokerFile);

            //Soronként
            foreach (string sor in adatok)
            {
                FileElem fi = new FileElem(sor);
                FaElem pill = gyokerElem;

                //Az új objektum neve alpaján megkeresni a helyét
                for (int i = 1; i < fi.Konyvtar.Length - 1; ++i)
                {
                    //Az egyes szinteken a szükséges almappa keresése
                    for (int j = 0; j < pill.Gyerekek.Count; ++j)
                    {
                        FileElem pillKonyvtar = pill.Gyerekek[j].Nev;

                        if (fi.Konyvtar[i] == pillKonyvtar.Konyvtar[pillKonyvtar.Konyvtar.Length-2])
                        {
                            pill = pill.Gyerekek[j];
                            break;
                        }
                    }
                }

                //
                pill.Gyerekek.Add(new FaElem(fi));
            }

            //A megfeleő mappába helyezés
            return gyokerElem;
        }
    }
}
